From 940d0fd53145000bf91a5fafd2aa1455aa717fa2 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 25/48] add TreeObj and RPMsMixin classes


These serve to share code between objects that represent non-leaf nodes
of a modulemd tree and those that contain a set of RPM names, especially
with regards to dispatching things to the native side, i.e. libmodulemd.

---

diff --git a/modulemd/legacy_wrappers.py b/modulemd/legacy_wrappers.py
new file mode 100644
index 0000000..a12d057
--- /dev/null
+++ b/modulemd/legacy_wrappers.py
@@ -0,0 +1,171 @@
+# -*- coding: utf-8 -*-
+
+
+# Copyright © 2016 - 2018 Red Hat, Inc.
+#
+# Permission is hereby granted, free of charge, to any person obtaining a copy
+# of this software and associated documentation files (the "Software"), to deal
+# in the Software without restriction, including without limitation the rights
+# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+# copies of the Software, and to permit persons to whom the Software is
+# furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included in
+# all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+# SOFTWARE.
+
+
+import inspect
+
+from gi.repository import Modulemd
+
+
+class _TreeObjBase(object):
+
+    # The defining properties of the particular tree object. Set this in child
+    # classes or a mixin.
+    tree_props = ()
+
+    # The name of the particular tree object. Set this in concrete child
+    # classes.
+    tree_identity = None
+
+
+class TreeObj(_TreeObjBase):
+    """Class representing a part of the tree for the legacy Python API."""
+
+    def __init__(self, parent=None, **kwargs):
+        # self.parent is r/o
+        self._parent = parent
+        super(TreeObj, self).__init__(**kwargs)
+
+    def __bool__(self):
+        return True
+
+    def __nonzero__(self):
+        return self.__bool__()
+
+    @property
+    def parent(self):
+        return self._parent
+
+    def replace(self, o):
+        if not isinstance(o, type(self)):
+            raise TypeError(
+                "{}: data type not supported".format(type(o).__name__))
+
+        props = set()
+        for base in inspect.getmro(type(self)):
+            props.update(getattr(base, 'tree_props', ()))
+
+        for prop in props:
+            setattr(self, prop, getattr(o, prop))
+
+
+class RPMsMixin(_TreeObjBase):
+    """Mixin supporting an 'rpms' property as a set.
+
+    Needs get/set_rpm_set() implemented in child classes."""
+
+    tree_props = ('rpms',)
+
+    def __init__(self, rpms=None, **kwargs):
+        if rpms is None:
+            rpms = set()
+        super(RPMsMixin, self).__init__(**kwargs)
+        self.rpms = rpms
+
+    def __bool__(self):
+        return (super(RPMsMixin, self).__bool__()
+                or True if self.rpms else False)
+
+    def get_rpm_set(self):
+        """Dispatch to native method for getting RPM sets.
+
+        This will be something like self.parent.module.get_rpm_*() or an
+        appropriate method on the associated native object."""
+        raise NotImplementedError()
+
+    def set_rpm_set(self, ss):
+        """Dispatch to native method for setting RPM sets.
+
+        This will be something like self.parent.module.set_rpm_*() or an
+        appropriate method on the associated native object."""
+        raise NotImplementedError()
+
+    @property
+    def rpms(self):
+        """A set of binary RPM packages defining this module's API."""
+        if self.parent:
+            return set(self.get_rpm_set().get())
+        else:
+            return self._rpms
+
+    @rpms.setter
+    def rpms(self, ss):
+        if ss is not None:
+            if not isinstance(ss, set):
+                raise TypeError("{}.rpms: data type not supported:"
+                                " {!r} (must be a set)".format(
+                                    self.tree_identity, ss))
+            for v in ss:
+                if not isinstance(v, str):
+                    raise TypeError("{}.rpms: data type not supported:"
+                                    " {!r} (elements must be strings)".format(
+                                        self.tree_identity, v))
+
+        if self.parent:
+            if ss is not None:
+                _ss = Modulemd.SimpleSet()
+                _ss.set(list(ss))
+            else:
+                _ss = None
+            self.set_rpm_set(_ss)
+        else:
+            self._rpms = ss
+
+    def add_rpm(self, s):
+        """Adds a binary RPM package to the API set.
+
+        :param str s: Binary RPM package name
+        """
+        if not isinstance(s, str):
+            raise TypeError("{}.add_rpm: data type not supported".format(
+                self.tree_identity))
+
+        if self.parent:
+            rpms = self.rpms
+            rpms.add(s)
+            self.rpms = rpms
+        else:
+            self._rpms.add(s)
+
+    def del_rpm(self, s):
+        """Removes the supplied package name from the package set.
+
+        :param str s: Binary RPM package name
+        """
+        if not isinstance(s, str):
+            raise TypeError("api.del_rpm: data type not supported")
+
+        if self.parent:
+            rpms = self.rpms
+            rpms.discard(s)
+            self.rpms = rpms
+        else:
+            self._rpms.discard(s)
+
+    def clear_rpms(self):
+        """Clear the API binary RPM package set."""
+
+        if hasattr(self, 'parent'):
+            self.rpms = set()
+        else:
+            self._rpms.clear()

